"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var ListShowComponent = (function () {
    function ListShowComponent() {
        this.showData = [];
        // [ [{name,id},{}] ]
        this.data = [];
        this.width = 80;
        this.showKey = 'name';
        this.idKey = 'id';
        this.removeItemEmit = new core_1.EventEmitter();
    }
    ListShowComponent.prototype.ngOnInit = function () {
        this.handleData();
    };
    ListShowComponent.prototype.ngOnChanges = function (simpleChanges) {
        console.log(simpleChanges);
    };
    ListShowComponent.prototype.handleData = function () {
        var temp = [];
        var boxW = this.listBox.nativeElement.offsetWidth - 50;
        var itemW = this.width - 0 + 20;
        var lineLen = Math.floor(boxW / itemW);
        if (!this.data || this.data.length == 0) {
            this.showData = this.data;
        }
        else {
            for (var i = 0; i < this.data.length; i++) {
                var dataI = this.data[i];
                if (temp.length == 0) {
                    temp.push([]);
                }
                var tempL = temp.length;
                temp[tempL - 1].push(dataI);
                if ((i + 1) % lineLen == 0 && i != this.data.length - 1) {
                    temp.push([]);
                }
            }
        }
        this.showData = temp;
    };
    ListShowComponent.prototype.addItem = function (item) {
        this.data.push(item);
        this.handleData();
    };
    ListShowComponent.prototype.removeItem = function (item, ev) {
        for (var i = 0; i < this.data.length; i++) {
            if (this.data[i][this.idKey] == item[this.idKey]) {
                this.data.splice(i, 1);
                break;
            }
        }
        this.handleData();
        if (ev) {
            this.removeItemEmit.emit(item);
        }
    };
    ListShowComponent.decorators = [
        { type: core_1.Component, args: [{
                    selector: 'dc-list-show',
                    template: "\n    <div class=\"show-box\" #listBox>\n      <ng-template ngFor let-items [ngForOf]=\"showData\" let-i=\"index\">\n        <div class=\"show-ul\">\n          <div class=\"show-list\" [style.width]=\"width + 'px'\" *ngFor=\"let item of items\">\n            {{item[showKey]}}\n            <span *ngIf=\"canDelete\" (click)=\"removeItem(item, $event)\">x</span>\n          </div>\n        </div>\n      </ng-template>\n      <div class=\"show-more\" *ngIf=\"showData.length > 1\">hideData({{data.length}})</div>\n    </div>\n  ",
                    styles: [
                        "\n      .show-box {\n        position: relative;\n        padding-right: 50px;\n      }\n\n      .show-ul {\n        display: flex;\n        flex-direction: row;\n        align-items: center;\n        flex-wrap: wrap;\n        position: relative;\n      }\n\n      .show-list {\n        border: 1px solid red;\n        height: 30px;\n        line-height: 30px;\n        text-align: center;\n        width: 80px;\n        text-overflow: ellipsis;\n        overflow: hidden;\n        margin-right: 20px;\n        flex-shrink: 0;\n      }\n\n      .show-more {\n        width: 50px;\n        position: absolute;\n        right: 0;\n        top: 0;\n        height: 30px;\n      }\n    "
                    ]
                },] },
    ];
    /** @nocollapse */
    ListShowComponent.ctorParameters = function () { return []; };
    ListShowComponent.propDecorators = {
        "data": [{ type: core_1.Input },],
        "width": [{ type: core_1.Input },],
        "showKey": [{ type: core_1.Input },],
        "idKey": [{ type: core_1.Input },],
        "canDelete": [{ type: core_1.Input },],
        "offsetWidth": [{ type: core_1.Input },],
        "removeItemEmit": [{ type: core_1.Output },],
        "listBox": [{ type: core_1.ViewChild, args: ['listBox',] },],
    };
    return ListShowComponent;
}());
exports.ListShowComponent = ListShowComponent;
//# sourceMappingURL=list.show.component.js.map